shell函数

时间:2021-04-07
本文章向大家介绍shell函数,主要包括shell函数使用实例、应用技巧、基本知识点总结和需要注意事项,具有一定的参考价值,需要的朋友可以参考一下。

1. 函数介绍

函数function是由若干条shell命令组成的语句块,实现代码重用和模块化编程 它与shell程序形式上是相似的,不同的是它不是一个单独的进程,不能独立运行,而是shell程序的一部分

函数和shell程序区别

  • Shell程序在子Shell中运行

  • 函数在当前Shell中运行。因此在当前Shell中,函数可对shell中变量进行修改

2. 管理函数

函数由两部分组成:函数名和函数体

帮助参看:help function

2.1 定义函数

简单的语法:

函数名(){
    函数体......
    return n
}

规范的语法:

function 函数名{
    函数体......
    return n
} 


function 函数名(){
    函数体......
    return n
} 

2.2 查看函数

# 查看当前已定义的函数名 
declare -F 
# 查看当前已定义的函数定义 
declare -f 
# 查看指定当前已定义的函数名 
declare -f func_name 
# 查看当前已定义的函数名定义 
declare -F func_name

2.3 删除函数

格式

unset func_name

3. 函数调用

函数的调用方式

  • 可在交互式环境下定义函数

  • 可将函数放在脚本文件中作为它的一部分

  • 可放在只包含函数的单独文件中

调用:函数只有被调用才会执行,通过给定函数名调用函数(直接执行函数名即可,不需要带小括号),函数名出现的地方,会被自动替换为函数代码

函数的生命周期:被调用时创建,返回时终止

3.1 交互式环境调用函数

交互式环境下定义和使用函数

示例

[root@centos8 ~]#dir() {
> ls -l
> }
[root@centos8 ~]#dir
total 208852
drwxr-xr-x. 2 root root        47 Mar 25 20:08 TEST

示例:实现判断CentOS的主版本

[root@centos8 ~]#os_version() {
> awk '{split($4,arr,".");print arr[1]}' /etc/redhat-release
> }
[root@centos8 ~]#os_version
8
[root@centos8 ~]#

3.2 在脚本中定义及使用函数

函数在使用前必须定义,因此应将函数定义放在脚本开始部分,直至shell首次发现它后才能使用,调用 函数仅使用其函数名即可

[root@centos8 ~/script]#cat reset.sh
#!/bin/bash
#
[ -f /etc/rc.d/init.d/functions ] &&  . /etc/rc.d/init.d/functions
disable_selinux(){
	sed -i.bak 's/SELINUX=enforcing/SELINUX=disabled/' /etc/selinux/config
	action "SElinux Has been disabled,Effective after restart"
}
disable_firewall(){
	systemctl disable --now firewalld &>/dev/null
	action "firewall Has been disabled"
}
set_ps1() {
	echo "PS1='\[\e[1;33m\][\u@\h \W]\\$\[\e[0m\]'" > /etc/profile.d/reset.sh
    action "The prompt has been modified successfully. Please log in again to take effect"
}
set_eth(){
	sed -i.bak '/GRUB_CMDLINE_LINUX=/s#"$# net.ifnames=0"#' /etc/default/grub
	grub2-mkconfig -o /boot/grub2/grub.cfg &> /dev/null
	action "The network name has been modified successfully. Please restart it to take effect"
}

PSS="Please Select number(1-6): "
MENU='
DisableSELinux
DisableFirewall
ModifyPrompt
ModifyNetwork
All
Exit
'
select MM in $MENU;do
case $REPLY in
1)
	disable_selinux
	;;
2)
	disable_firewall
	;;
3)
	set_ps1
	;;
4)
	set_eth
	;;
5)
	disable_selinux
	disable_firewall
	set_ps1
	set_eth
	;;
6)
	break
	;;
*)
	echo "Please enter the correct number"
esac
done
[root@centos8 ~/script]#

3.3 使用函数文件

可以将经常使用的函数存入一个单独的函数文件,然后将函数文件载入shell,再进行调用函数

函数文件名可任意选取,但最好与相关任务有某种联系,例如:functions

一旦函数文件载入shell,就可以在命令行或脚本中调用函数。可以使用delcare -f 或 set 命令查看所有 定义的函数,其输出列表包括已经载入 shell 的所有函数

若要改动函数,首先用unset命令从shell中删除函数。改动完毕后,再重新载入此文件

实现函数文件的过程:

  1. 创建函数文件,只存放函数的定义
  2. 在shell脚本或交互式shell中调用函数文件,格式如下:
. ./filename
source filename

示例

#!/bin/bash
# source function library
[ -f /etc/rc.d/init.d/functions ] &&  . /etc/rc.d/init.d/functions
if [ "$1" == "start"  ] ;then
    action "nginx is starting." /bin/true
elif  [ "$1" == "stop" ];then
    action "nginx is stoped." /bin/true
else
    echo "USAGE:$0 {start|stop}"
    action "nginx start" /bin/false
    exit
fi

4. 函数返回值

函数的执行结果返回值:

  • 使用echo等命令进行输出

  • 函数体中调用命令的输出结果

函数的退出状态码:

  • 默认取决于函数中执行的最后一条命令的退出状态码

  • 自定义退出状态码,其格式为:

header 1 header 2
return 从函数中返回,用最后状态命令决定返回值
return 0 无错误返回
return 1-255 有错误返回

5. 环境函数

类拟于环境变量,也可以定义环境函数,使子进程也可使用父进程定义的函数

定义环境函数:

export  -f  function_name
declare -xf function_name

查看环境函数

export  -f
declare -xf

6. 函数参数

函数可以接受参数

  • 传递参数给函数:在函数名后面以空白分隔给定参数列表即可,如:testfunc arg1 arg2 ..

  • 在函数体中当中,可使用$1, $2, ...调用这些参数;还可以使用$@, $*, $#等特殊变量

示例:实现进度条功能

[root@centos8 ~/script]#cat progress_chart.sh
#!/bin/bash
#
function print_chars(){
	local char="$1"
	local number="$2"
	local c
	for((c=0;c<number;++c))
	do
		printf "$char"
	done
}
COLOR=33
declare -i end=50
for ((i=1;i<=end;++i))
do
	printf "\e[1;${COLOR}m\e[80D["
	print_chars "#" $i
	print_chars " " $((end - i))
	printf "] %3d%%\e[0m" $((i * 2))
	sleep 0.1s
done
echo
[root@centos8 ~/script]#bash progress_chart.sh
[##################################################] 100%
[root@centos8 ~/script]#

带参数的函数执行方法:函数名 参数1 参数2

  • 函数带参数的说明

    • 在函数体中位置参数($1 $2 $3 $4 $5 $# $* $?以及$@)都可以是函数的参数

    • 父脚本的参数则临时被函数参数所掩盖或隐藏

    • $0 比较特殊,仍然为父脚本的名称

    • 当函数完成时,原来的命令行参数会恢复

    • 在 shell 函数里面,return 命令的功能与工作方式与exit相同,用于跳出函数

    • 在 shell 函数体里使用 exit 会终止整个 shell 脚本

    • return 语句会返回一个退出值给调用的程序

函数和执行脚本分离:

#!/bin/bash
# 加载函数
[ -x /etc/init.d/functions ] && . /etc/init.d/function||exit

# 调用函数
function_name1
function_name2

示例1:带参数的shell函数例子

#!/bin/bash
check_url(){
    curl -I -s $1 |head -1 && return 0||return 1
}
check_url www.baidu.com

例2:函数传参转成脚本命令行传参

[@sjs_115_196 ~]# cat test.sh
#!/bin/bash
if [ $# -ne 1 ];then
    echo "error" 
    exit  1
fi
check_url(){
    curl -I -s $1 |head -1 && return 0||return 1
}
check_url $1
[@sjs_115_196 ~]# sh test.sh www.baidu.com
HTTP/1.1 200 OK
[@sjs_115_196 ~]# sh test.sh 
error
[@sjs_115_196 ~]#

函数里面的 $1 属于函数的参数

函数外面的 $1 属于脚本的参数

[@sjs_115_196 ~]# cat test.sh
#!/bin/bash
test(){
    echo "$1"
}
test 127.0.0.1 
echo $1
[@sjs_115_196 ~]# sh test.sh      
127.0.0.1

[@sjs_115_196 ~]# sh test.sh 12345
127.0.0.1
12345
[@sjs_115_196 ~]#

7. 函数变量

变量作用域:

  • 普通变量:只在当前shell进程有效,为执行脚本会启动专用子shell进程;因此,本地变量的作用 范围是当前shell脚本程序文件,包括脚本中的函数

  • 环境变量:当前shell和子shell有效

  • 本地变量:函数的生命周期;函数结束时变量被自动销毁

注意:

  • 如果函数中定义了普通变量,且名称和局部变量相同,则使用本地变量

  • 由于普通变量和局部变量会冲突,建议在函数中只使用本地变量

在函数中定义本地变量的方法

local NAME=VALUE

7.1 局部变量

[@sjs_115_196 ~]# cat test.sh
#!/bin/bash
function main()
{
    echo "hello world"
    local var=123         # 局部变量输出为空值
}
main
echo $var
[@sjs_115_196 ~]# sh test.sh  
hello world

[@sjs_115_196 ~]#

7.2 全局变量

[@sjs_115_196 ~]# cat test.sh
#!/bin/bash
function main()
{
    echo "hello world"
    var=123            # 全局变量,输出变量的值
}
main
echo $var
[@sjs_115_196 ~]# sh test.sh
hello world
123
[@sjs_115_196 ~]# 

7.3 父子shell

[@sjs_115_196 ~]# cat test.sh
#!/bin/bash
user=`whoami`
echo $user
[@sjs_115_196 ~]# sh test.sh
root
[@sjs_115_196 ~]# echo $user    # 输出为空值

[@sjs_115_196 ~]#

shell脚本的执行不是在当前shell中执行,而是新开一个子shell执行

父shell中变量的改变是影响子shell的

子shell中变量的改变不影响父shell

8. 函数递归

函数递归:函数直接或间接调用自身,注意递归层数,可能会陷入死循环

递归示例:

阶乘是基斯顿·卡曼于 1808 年发明的运算符号,是数学术语,一个正整数的阶乘(factorial)是所有小 于及等于该数的正整数的积,并且0和1的阶乘为1,自然数n的阶乘写作n!

n!=1×2×3×...×n

阶乘亦可以递归方式定义:0!=1,n!=(n-1)!×n

n!=n(n-1)(n-2)...1

n(n-1)! = n(n-1)(n-2)!

示例:fact.sh

[root@centos8 ~/script]#cat fact.sh
#!/bin/bash
#
fact(){
	if [ $1 -eq 0 -o $1 -eq 1 ];then
		echo 1
	else
		echo $[$1*$(fact $[$1-1])]
	fi
}
fact $1
[root@centos8 ~/script]#bash fact.sh 1
1
[root@centos8 ~/script]#bash fact.sh 2
2
[root@centos8 ~/script]#bash fact.sh 3
6
[root@centos8 ~/script]#bash fact.sh 4
24
[root@centos8 ~/script]#

示例:测试递归的嵌套深度

[root@centos8 ~]#test(){
    let i++
    echo i=$i
    test 
}
[root@centos8 ~]#test

fork 炸弹是一种恶意程序,它的内部是一个不断在 fork 进程的无限循环,实质是一个简单的递归程 序。由于程序是递归的,如果没有任何限制,这会导致这个简单的程序迅速耗尽系统里面的所有资源

函数实现

:(){ :|:& };:
 bomb() { bomb | bomb & }; bomb

脚本实现

cat Bomb.sh
#!/bin/bash
./$0|./$0&
 

原文地址:https://www.cnblogs.com/wysxr/p/14629127.html